<?php
    // Archivo para obtener la informacin de tickets abiertos y cerrados entre los regionales qeu se seleccionan en regionales.php

    // Utiliza el archivo iCompara en la carperta de interfaz y el archivo de Database en database
    require_once('../database/Database.php');
    require_once('../interface/iCompara.php');

    // Creacin de la clase compara implementando la interfaz de iCompara
    class Compara extends Database implements iCompara{

        // funcin que obtiene la cantidad de tickets abiertos y cerrados entre los regionales seleccionados
        public function compara_id_compara($fechaini, $fechafin, $tipo, $regionales){
            $sql = "SELECT SUM(uni.abiertos) AS abiertos, SUM(uni.cerrados) AS cerrados, (SUM(uni.abiertos) + SUM(uni.cerrados) ) AS cuantos, uni.regional FROM(
                SELECT count(*) AS abiertos, 0 AS cerrados, ost6.name AS regional
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                     SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                         $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%')";
                    }
                }
                $sql .= " AND ost1.closed IS NULL
                AND ost6.id IN ($regionales)
                GROUP BY ost6.name
                UNION ALL 
                SELECT 0 AS abiertos, count(*) AS cerrados, ost6.name AS regional
                FROM ost_ticket__cdata ost2 
                INNER JOIN ost_ticket ost1 ON ost2.ticket_id=ost1.ticket_id 
                INNER JOIN ost_staff ost3 ON ost3.staff_id=ost1.staff_id 
                INNER JOIN ost_help_topic ost4 ON ost1.topic_id=ost4.topic_id 
                INNER JOIN ost_user ost5 ON ost1.user_id = ost5.id 
                INNER JOIN ost_organization ost6 ON ost6.id = ost5.org_id
                INNER JOIN rot_sucursal ost7 ON ost5.id_sucursal COLLATE utf8_unicode_ci = ost7.id_sucursal COLLATE utf8_unicode_ci 
                INNER JOIN ost_department ost8 ON ost3.dept_id = ost8.id
                INNER JOIN (
                     SELECT @row_number:= CASE
                    WHEN @object_id = object_id 
            			THEN @row_number + 1
                    ELSE 1 END 
                	AS rn,  @object_id := ost9.object_id as object_id, ost9.id, ost10.thread_id, ost10.event_id, MAX(ost10.timestamp) AS timestamp
                    FROM ost_thread_event ost10 INNER JOIN ost_thread ost9 ON ost9.id = ost10.thread_id AND ost10.event_id = 4
                    GROUP BY ost9.object_id
                    ORDER BY ost9.object_id, ost10.timestamp DESC)
                ost11 ON ost1.ticket_id = ost11.object_id AND ost11.rn = 1 ";
                if($fechaini != $fechafin){

                    $fechaini = $fechaini.' 00:00:00';
                    $fechafin = $fechafin.' 23:59:59';

                    if($tipo == "All"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Open"){
                         $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."'
                        OR ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."') AND ost1.closed IS NULL" ;
                    }
                    elseif($tipo == "Created"){
                        $sql .= "WHERE (ost1.created BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .= "WHERE (ost1.lastupdate BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .= "WHERE (ost1.closed BETWEEN '".$fechaini."' AND '".$fechafin."')";
                    }
                }
                else{
                    if($tipo == "All"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%'
                        OR ost1.lastupdate like '".$fechaini."%'
                        OR ost1.closed like '".$fechaini."%')";
                    }
                    elseif($tipo == "Open"){
                        $sql .= "WHERE (ost1.created like '".$fechaini."%' OR ost1.lastupdate like '".$fechaini."%') AND ost1.closed IS NULL";
                    }
                    elseif($tipo == "Created"){
                        $sql .="WHERE (ost1.created like '".$fechaini."%')";
                    }
                    elseif($tipo == "Updated"){
                        $sql .="WHERE (ost1.lastupdate like '".$fechaini."%')";
                    }
                    elseif($tipo == "Closed"){
                        $sql .="WHERE (ost1.closed like '".$fechaini."%')";
                    }
                }
                $sql .= " AND ost1.closed IS NOT NULL 
                AND ost6.id IN ($regionales)
                GROUP BY ost6.name) AS uni
            GROUP BY uni.regional;";
            return $this->getRows($sql);
        }

    }

    // Objetos para usar en compara.php en data
    $compara = new Compara();
?>