<?php 

	// Se incluye la conexión
	include_once('Connection.php');

	// La clase Database tiene herencia de Connection en Connection.php
	class Database extends Connection{

		// En el contructor se instancia el contructor de la clase "Padre" de la que esta heredando
		public function __construct(){
			parent::__construct();
		}

	// Para el CRUD la estructura general es recibir el query y los parametros del mismo

		//Obtiene el resultado de la consulta y devuelve una sola columna
		public function getRow($query, $params = []){
			try {
				$stmt = $this->datab->prepare($query);
				$stmt->execute($params);
				return $stmt->fetch();	
			} catch (PDOException $e) {
				throw new Exception($e->getMessage());	
			}
		}

		//Obtiene el resultado de la consulta y devuelve un arreglo contodo el contenido
		public function getRows($query, $params = []){
			try {
				$stmt = $this->datab->prepare($query);
				$stmt->execute($params);
			    return $stmt->fetchAll();	
			} catch (PDOException $e) {
				throw new Exception($e->getMessage());
			}
		}

		//Inserta una columna en una tabla de acuerdo al query
		public function insertRow($query, $params = []){
			try {
				$stmt = $this->datab->prepare($query);
				$stmt->execute($params);
				return TRUE;	
			} catch (PDOException $e) {
				throw new Exception($e->getMessage());	
			}
		}

		//Actualiza una tabla de acuerdo al query
		public function updateRow($query, $params = []){
			$this->insertRow($query, $params);
			return true;
		}

		//Elimina una columna de una tabla de acuerdo al query
		public function deleteRow($query, $params = []){
			$this->insertRow($query, $params);
			return true;
		}

		//Obtiene el última ID insertado en la tabl
		public function lastID(){
			$lastID = $this->datab->lastInsertId(); 
			return $lastID;
		}

		//Crea una transacción
		public function transInsert($query, $params = [], $query2, $params2 = []){
			try {
				$this->transaction->beginTransaction();
					$stmt = $this->datab->prepare($query);
					$stmt->execute($params);

					$stmt2 = $this->datab->prepare($query2);
					$stmt2->execute($params2);

				$this->transaction->commit();
			} catch (PDOException $e) {
				$this->transaction->rollBack();
				throw new Exception($e->getMessage());	
			}
		}

		//Inicio de una transacción
		public function Begin(){
			$this->transaction->beginTransaction();
		}

		// Realiza el contenido de una trnasacción
		public function Commit(){
			$this->transaction->commit();
		}

		// Prueba de conexión
		public function test()
		{
			echo 'Test de conexión';
		}
	}

 ?>