//Configuración al cargar la página de Categoria
$(document).ready(function() {

	// Configuración del Datatable
	$('#Categoria').DataTable({
        "language": {													//Idioma
            "lengthMenu": " _MENU_ columnas por página",				//Para el cambio de registros por página
            "zeroRecords": "Ningún resultado",							//Lo que se muestra en la tabla cuando no encuentra coincidencias con la busqueda
            "info": "Página _PAGE_ de _PAGES_",							//Paginación
            "infoEmpty": "No hay registros",							//Lo que se muestra en la tabla cuando no se tiene registros
            "infoFiltered": "(Filtro de _MAX_ registros totales)",		//Mensaje de filtro
            "search": "Buscar","paginate": {							//Búsqueda y botones para moverse en la tabla
                "first": "Primero",
                "last": "Último",
                "next": "Siguiente",
                "previous": "Anterior"
            },
        },
		dom: "Bfrtpi",													//Elementos que se muestran en el contenedor Boton, Búsqueda, Tabla, Paginación, indexación
		buttons: [														//Configuración de botón para exportar a excel
			{
				extend: 'excelHtml5',
				text: '<i class="fas fa-file-excel"></i>',
				titleAttr: 'Exportar a Excel',
				className: 'btn btn-success'
			},
		],
    });
});

// Función que redirecciona a la página categoria con los parámetros de filtrado establecidos
$(document).on('submit', '#categoria_tiempo', function(event) {
	event.preventDefault();

	// Obtiene los valores del form en categorias.php
	let fechaini = document.getElementById('categoria_fechaini').value;
	let fechafin = document.getElementById('categoria_fechafin').value;
	let buscar = document.getElementById('categoria_buscar').value;
	let categoria = document.getElementById('categoria_cat').value;

	// Redirecciona a la página agregando los parámetros
	$.ajax({
		url: 'categoria.php',
		success: function() {    
			location.href = "categoria.php?fechaini="+fechaini+"&fechafin="+fechafin+"&tipo="+buscar+"&cat="+categoria;
		},
		error:function(){
			alert("error");
		}
	});
});

// Gráficas de las categorias
function Categoria_graficas(count){

	// Arreglos
	let Cuantos = [];
	let abiertos = [];
	let cerrados = [];
    let Topic = [];

	//Proceso para obtener los valores del arreglo y ponerlo en arreglos separados para trabajarlos
	for (let i in count) {
		Cuantos.push(count[i].cuantos);
		Topic.push(count[i].topic);
		abiertos.push(count[i].abiertos);		
		cerrados.push(count[i].cerrados);
	}

	// Proceso para obtener el total de tickets
	let suma = 0;
	Cuantos.forEach (function(numero){
        suma += parseInt(numero);
    });

	// Proceso para obtener el porcentaje de cada categoria respecto al total de tickets 
	let porciento = []
	Cuantos.forEach (function(numero){
        porciento.push(((numero * 100)/suma).toFixed(2));
    });

	// Proceso para mostrar la cadena de categoría y porcentaje de tickets levantados
	let final = [];
    for (let i in Topic) {
		final.push(Topic[i] +  ' - '  + porciento[i] + '%');
	}

	// Arreglo de colores para la gráfica de pastel(Azul, Cian, Verde, Naranja, Morado, Rosa, Lavanda, Café, Rojo, Amarillo, Gris, Negro)
	let color = ['#CD5C5C', '#8B0000', '#FFC0CB', '#DB7093', '#FFA07A', '#FFA500', '#FFD700', '#BDB76B', '#D8BFD8', '#7B68EE', '#ADFF2F', 
		'#008080', '#00FFFF', '#191970', '#FFEBCD', '#800000', '#DCDCDC', '#000000', '#FA8072', '#FF0000', '#FF69B4', '#C71585', '#FF6347', 
		'#FF8C00', '#FFFF00', '#F0E68C', '#EE82EE', '#6A5ACD', '#7CFC00', '#20B2AA', '#48D1CC', '#00008B', '#BC8F8F', '#A52A2A', '#2F4F4F',
		'#DC143C', '#FF1493', '#FF4500', '#FF00FF', '#8A2BE2', '#32CD32', '#808000', '#4682B4', '#4169E1', '#CD853F', '#F4A460', '#00BFFF', 
		'#1E90FF', '#008000', '#00FF7F'];
	
	// Proceso para obtener el tamaño de la pantalla y así mostrar o no los encabezados de la gráfica de pastel
	let condicion
	if(window.innerWidth < 1150){
		condicion = false;
	}
	else{
		condicion = true;
	}

	// Gráfica de pastel
	// Estructura:
	// Obtiene el div donde se mostrará la gráfica
	// Creación del objeto gráfica
	// Tipo de gráfica
	// Configuración de información:
		// Texto que muestra cuando se le sobrepone el cursor
		// Colores de las barras
		// Colores de las barras cuando se le sobrepone el cursor
		// Colores del borde cuando se le sobrepone el cursor
	// Cofiguración de visialización
		//Fondo del div
		//Color de la fuente
		//Color del borde
		//Tamaño del borde
		//Espaciado vertical
		//Espaciado horizontal
		//Muestra o no los encabezados
		//Tamaño de la circunferencia del centro
	let circular = document.getElementById("categoria_Circular");
	new Chart(circular, {
		type: 'pie',
		data: {
		  	labels: final,
		  	datasets: [{
				label: Topic,
				data: Cuantos,
				backgroundColor: color,
				hoverBorderColor: "rgba(234, 236, 244, 1)",
		  	}],
		},
		options: { 
		  	maintainAspectRatio: false,
		  	tooltips: {
				backgroundColor: "rgb(255,255,255)",
				bodyFontColor: "#858796",
				borderColor: '#dddfeb',
				borderWidth: 1,	
				xPadding: 1,
				yPadding: 1,
		  	},
		  	legend: {
				display: condicion,
		  	},
		  	cutoutPercentage: 2,
		},
	});
}