//Configuración al cargar la página de Regional
$(document).ready(function() {

	// Configuración del Datatable
	$('#Regional').DataTable({
        "language": {													//Idioma
            "lengthMenu": " _MENU_ columnas por página",				//Para el cambio de registros por página
            "zeroRecords": "Ningún resultado",							//Lo que se muestra en la tabla cuando no encuentra coincidencias con la busqueda
            "info": "Página _PAGE_ de _PAGES_",							//Paginación
            "infoEmpty": "No hay registros",							//Lo que se muestra en la tabla cuando no se tiene registros
            "infoFiltered": "(Filtro de _MAX_ registros totales)",		//Mensaje de filtro
            "search": "Buscar","paginate": {							//Búsqueda y botones para moverse en la tabla
                "first": "Primero",
                "last": "Último",
                "next": "Siguiente",
                "previous": "Anterior"
            },
        },
		dom: "Bfrtpi",													//Elementos que se muestran en el contenedor Boton, Búsqueda, Tabla, Paginación, indexación
		buttons: [														//Configuración de botón para exportar a excel
			{
				extend: 'excelHtml5',
				text: '<i class="fas fa-file-excel"></i>',
				titleAttr: 'Exportar a Excel',
				className: 'btn btn-success'
			},
		],
    });
});

// obtiene el elemento donde se muestra el regional que se busca
const modreg = document.getElementById('regional_regional');

// Al tener el foco en el elemento muestra el modal para buscar el regional 
modreg.addEventListener('focus', () => {
    $('.busca_reg').load('buscaRegional.php', function(){
        $('#modal_SelectRegional').modal('show');
    });
});

//Búsquedas dinámicas
function BuscaRegional(){
    let parametros = "parametros="+$('#regional_busca').val();
    $.ajax({
        data: parametros,
        url: 'regionales.php',
        type: 'post',
        success: function (response){
            $("#contenido").html(response);
        },
        error:function(){
            alert('error');
        }
    });
}

// obtiene el regional seleccionada y oculta el modal
function SelectReg(id){
    document.getElementById('regional_regional').value = id;
    $('#modal_SelectRegional').modal('hide');
}

// Función que redirecciona a la página sucursal con los parámetros de filtrado establecidos
$(document).on('submit', '#regional_tiempo', function(event){
    event.preventDefault();

    // Obtiene los calores del form en regional.php
    let fechaini = document.getElementById('regional_fechaini').value;
	let fechafin = document.getElementById('regional_fechafin').value;
	let buscar = document.getElementById('regional_buscar').value;
	let categoria = document.getElementById('regional_cat').value;
	let regional = document.getElementById('regional_regional').value;

    // Redireccional a la página agregando los parámetros
    $.ajax({
        url: 'regional.php',
        success: function(){
            location.href = "regional.php?fechaini="+fechaini+"&fechafin="+fechafin+"&tipo="+buscar+"&cat="+categoria+"&reg="+regional;
		},
		error:function(){
			alert("error");
		}
	});
});

function Regional_graficas(reg1, reg2){

    // Crea arreglos y los asigna con el arreglo recibido 'reg2'
    let abiertos = [];
    let cerrados = [];
    let regional = [];
    for(let i in reg2){
        abiertos.push(reg2[i].abiertos);
        cerrados.push(reg2[i].cerrados);
        regional.push(reg2[i].regional);
    }

    // crea la primera grafica de barras con los tickets abiertos
    let open = {
        label: 'abiertos',
        data: abiertos,
        backgroundColor: '#E74A3B',
        hoverBackgroundColor: '#EA221F',
        hoverBorderColor: "rgba(234, 236, 244, 1)",
    }

    // crea la segunda grafica de barras con los tickets cerrados
    let close = {
        label: 'cerrados',
        data: cerrados,
        backgroundColor: '#1cc88a',
        hoverBackgroundColor: '#17a673',
        hoverBorderColor: "rgba(234, 236, 244, 1)",
    }

    // Gráfica de barras
	// Estructura:
	// Obtiene el div donde se mostrará la gráfica
	// Creación del objeto gráfica
	// Tipo de gráfica
	// Configuración de información:
		// Es la información de open y close
	// Cofiguración de visialización
		// Empieza la gráfica en 0
		// No muestra los encabezados
    let total = document.getElementById("regional_Total");
	new Chart(total, {
		type: 'bar',
		data: {
		  	labels: regional,
		  	datasets: [
                open,
                close
            ],
		},
		options: {
			maintainAspectRatio: false,
			scales: {
				y: {
					beginAtZero: true
				}
			},
		  	legend: {
				display: true,
		  	},
		},
	});

    let reg1_abierto = parseInt(reg1['abiertos']);
    let reg1_cerrado = parseInt(reg1['cerrados']);

    // Estructura:
	// Obtiene el div donde se mostrará la gráfica
	// Creación del objeto gráfica
	// Tipo de gráfica
	// Configuración de información:
		// Texto que muestra cuando se le sobrepone el cursor
		// Colores de las barras
		// Colores de las barras cuando se le sobrepone el cursor
		// Colores del borde cuando se le sobrepone el cursor
	// Cofiguración de visialización
		//Fondo del div
		//Color de la fuente
		//Color del borde
		//Tamaño del borde
		//Espaciado vertical
		//Espaciado horizontal
		//Muestra o no los encabezados
		//Tamaño de la circunferencia del centro

    let circular = document.getElementById("regional_Circular");
	new Chart(circular, {
		type: 'pie',
		data: {
		  	labels: ["abiertos", "Cerrados"],
		  	datasets: [{
				data: [reg1_abierto, reg1_cerrado],
				backgroundColor: ['#E74A3B', '#1cc88a'],
				hoverBackgroundColor: ['#EA221F', '#17a673'],
				hoverBorderColor: "rgba(234, 236, 244, 1)",
		  	}],
		},
		options: {
		  	maintainAspectRatio: false,
		  	tooltips: {
				backgroundColor: "rgb(255,255,255)",
				bodyFontColor: "#858796",
				borderColor: '#dddfeb',
				borderWidth: 1,
				xPadding: 1,
				yPadding: 1,
		  	},
		  	legend: {
				display: false,
		  	},
		  	cutoutPercentage: 2,
		},
	});

    // Gráfica de barras
	// Estructura:
	// Obtiene el div donde se mostrará la gráfica
	// Creación del objeto gráfica
	// Tipo de gráfica
	// Configuración de información:
		// Texto que muestra cuando se le sobrepone el cursor
		// Colores de las barras
		// Colores de las barras cuando se le sobrepone el cursor
		// Colores del borde cuando se le sobrepone el cursor
	// Cofiguración de visialización
		// Empieza la gráfica en 0
		// No muestra los encabezados
    let barra = document.getElementById("regional_Barras");
	new Chart(barra, {
		type: 'bar',
		data: {
		  	labels: ["abiertos", "Cerrados"],
		  	datasets: [{
				data: [reg1_abierto, reg1_cerrado],
				backgroundColor: ['#E74A3B', '#1cc88a'],
				hoverBackgroundColor: ['#EA221F', '#17a673'],
				hoverBorderColor: "rgba(234, 236, 244, 1)",
		  	}],
		},
		options: {
			maintainAspectRatio: false,
			scales: {
				y: {
					beginAtZero: true
				}
			},
		  	legend: {
				display: false,
		  	},
		},
	});

}

// funcion para crear una grafica de barras que compare los tickets de los regionales seleccionados
function comparaRegional(){
    let regionales = [];
    let fechaini = document.getElementById('regional_fechaini').value;
	let fechafin = document.getElementById('regional_fechafin').value;
	let tipo = document.getElementById('regional_buscar').value;
    $("input[type=checkbox]:checked").each(function(){
        regionales.push(this.value);
    });
    
    $.ajax({
        url: 'data/compara.php',
        type: 'post',
        dataType: 'json',
        data: {
            regionales : regionales,
            fechaini : fechaini,
            fechafin : fechafin,
            tipo : tipo,
        },
        success: function(data){
            document.getElementById("regional_comparativa").value = ""; 
            let abiertos = [];
            let cerrados = [];
            let regional = [];
            for(let i in data.contenido){
                abiertos.push(data.contenido[i].abiertos);
                cerrados.push(data.contenido[i].cerrados);
                regional.push(data.contenido[i].regional);
            }
            let open = {
                label: 'abiertos',
                data: abiertos,
                backgroundColor: '#E74A3B',
                hoverBackgroundColor: '#EA221F',
                hoverBorderColor: "rgba(234, 236, 244, 1)",
            }
        
            let close = {
                label: 'cerrados',
                data: cerrados,
                backgroundColor: '#1cc88a',
                hoverBackgroundColor: '#17a673',
                hoverBorderColor: "rgba(234, 236, 244, 1)",
            }
        
            let comp = document.getElementById("regional_comparativa");
            if (window.grafica) {
                window.grafica.clear();
                window.grafica.destroy();
            }
            window.grafica = new Chart(comp, {
                type: 'bar',
                data: {
                      labels: regional,
                      datasets: [
                        open,
                        close
                    ],
                },
                options: {
                    maintainAspectRatio: false,
                    scales: {
                        y: {
                            beginAtZero: true
                        }
                    },
                      legend: {
                        display: true,
                      },
                },
            });
        },
        error: function(jqXHR){
            console.log(jqXHR.responseText);
        }
    });
}